#ifndef _FFHEAP_H_
#define _FFHEAP_H_

#include "dllisttype.h"

namespace HL {

//class FFHeap: a heap using the first-fit policy
template<int Type, class SuperHeap>
class FFHeap : public SuperHeap {
  public:
	inline void * malloc(size_t size) {
		void * ptr = free_list.getListNext(NULL);
		while (ptr != NULL && getSize(ptr) < size) {
			ptr = free_list.getListNext(reinterpret_cast<DLListEntry *>(ptr));
		}

		if (ptr == NULL) {
			ptr = SuperHeap::malloc(size);
			assert(ptr != NULL);
		}
		else {
			assert(getSize(ptr) >= size);
			free_list.remove(reinterpret_cast<DLListEntry *>(ptr));
		}

		return ptr;
	}

	inline void free(void * ptr) {
		free_list.insert(reinterpret_cast<DLListEntry *>(ptr));
	}

	inline void remove(void * ptr) {
		free_list.remove(reinterpret_cast<DLListEntry *>(ptr));
	}

  private:
	DLListType<Type> free_list;

};	//end of class FFHeap
};	//end of namespace HL

#endif
