#ifndef _NFHEAP_H_
#define _NFHEAP_H_

#include "dllisttype.h"

namespace HL {

//class NFHeap: a heap using the next-fit policy
template<int Type, class SuperHeap>
class NFHeap : public SuperHeap {
  public:
	inline NFHeap() : next_start(NULL) {}

	inline void * malloc(size_t size) {
		void * ptr = free_list.getListNext(reinterpret_cast<DLListEntry *>(next_start));
		while (ptr != NULL && getSize(ptr) < size) {
			ptr = free_list.getListNext(reinterpret_cast<DLListEntry *>(ptr));
		}

		if (ptr == NULL) {
			ptr = SuperHeap::malloc(size);
			assert(ptr != NULL);
		}
		else {
			assert(getSize(ptr) >= size);
			free_list.remove(reinterpret_cast<DLListEntry *>(ptr));
		}

		return ptr;
	}

	inline void free(void * ptr) {
		free_list.insert(reinterpret_cast<DLListEntry *>(ptr));
	}

	inline void remove(void * ptr) {
		free_list.remove(reinterpret_cast<DLListEntry *>(ptr));
	}

  private:
	DLListType<Type> free_list;
	void * next_start;

};	//end of class NFHeap
};	//end of namespace HL

#endif
