#ifndef _SHRINKBRKHEAP_H_
#define _SHRINKBRKHEAP_H_

namespace HL {

//class ShrinkBrkHeap: shrink current break when free object is at the end of heap
template<class SuperHeap>
class ShrinkBrkHeap : public SuperHeap {
  public:

	inline void free(void * ptr) {
		size_t size = getSize(ptr);

		if (shrink_brk(getHeader(ptr), size + sizeof(Header))) {
			setSize(ptr, 0);
			markInUse(ptr);
		}
		else {
			SuperHeap::free(ptr);
		}
	}

};	//end of class ShrinkBrkHeap

};	//end of namespace HL

#endif
