/* -*- C++ -*- */

/*

  Heap Layers: An Extensible Memory Allocation Infrastructure
  
  Copyright (C) 2000-2003 by Emery Berger
  http://www.cs.umass.edu/~emery
  emery@cs.umass.edu
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*
 * @file   liblea.cpp
 * @brief  This file replaces malloc etc. in your application.
 * @author Emery Berger <http://www.cs.umass.edu/~emery>
 */

#include <stdlib.h>
#include <new>

volatile int anyThreadCreated = 1;

#include "heaplayers.h"
#include "dlheap.h"
#include "oneheap.h"
#include "chunkheap.h"
#include "slopheap.h"


/// The Lea heap.
#if 0
#include "../reap/regionheap.h"
class TheCustomHeapType :
  public ANSIWrapper<
  LeaHeap<
  SlopHeap<RegionHeap<ChunkHeap<65536, MmapHeap> > >,
  RegionHeap<MmapHeap> > > {};
#else
// 32 bytes of extra slop here.
class TheCustomHeapType :
  public ANSIWrapper<
  LeaHeap<
  SlopHeap<ChunkHeap<65536, MmapHeap>, 32>,
  MmapHeap> > {};
#endif

inline static TheCustomHeapType * getCustomHeap (void) {
  static char thBuf[sizeof(TheCustomHeapType)];
  static TheCustomHeapType * th = new (thBuf) TheCustomHeapType;
  return th;
}

#if defined(_WIN32)
#pragma warning(disable:4273)
#endif

#include "wrapper.cpp"

