/* -*- C++ -*- */

// Author: Emery Berger, http://www.cs.umass.edu/~emery
//
// Copyright (c) 1998-2003, The University of Texas at Austin.
//
// This library is free software; you can redistribute it and/or modify
// it under the terms of the GNU Library General Public License as
// published by the Free Software Foundation, http://www.fsf.org.
//
// This library is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
//////////////////////////////////////////////////////////////////////////////

#if defined(_WIN32)
#error "This library is for UNIX only."
// This is because it requires dlsym and family.
#endif


#include <stdlib.h>
#include <dlfcn.h>

#if !defined(RTLD_NEXT)
#define RTLD_NEXT ((void *) -1)
#endif

volatile int anyThreadCreated = 1;

extern "C" {

  size_t malloc_usable_size (void *) throw();

  typedef void * mallocFunction (size_t);
  typedef void freeFunction (void *);
  typedef size_t msizeFunction (void *);

  typedef void exitFunction (int);

}

#include <heaplayers.h>

#include "logheap.h"

#if 0
#include "sizeheap.h"
#include "ansiwrapper.h"
#include "staticheap.h"
#endif

#include "localmallocheap.h"

using namespace HL;

class TheCustomHeapType :
  public LockedHeap<SpinLockType, LogHeap<LocalMallocHeap> > {};

inline static TheCustomHeapType * getCustomHeap (void) {
  static char thBuf[sizeof(TheCustomHeapType)];
  static TheCustomHeapType * th = new (thBuf) TheCustomHeapType;
  return th;
}

#if 1
extern "C" {
  void __attribute__((noreturn)) exit (int status) {
    getCustomHeap()->write();
    exitFunction * fn = (exitFunction *) trueExitFunction;
    if (fn) {
      (*fn)(status);
    }
  }
}
#endif

#if defined(_WIN32)
#pragma warning(disable:4273)
#endif

#include "wrapper.cpp"

