/* $Log: calloc.c,v $
/* Revision 1.1  2003/10/15 15:58:50  emery
/* Initial check-in.
/*
/* Revision 1.2  2003/05/08 21:42:29  emery
/* Ritual check-in.
/*
/* Revision 1.1  2001/08/23 17:19:36  emery
/* The big fig newton.
/*
/* Revision 1.1.1.1  2001/06/28 19:48:16  dgay
/* Initial import of RC tests
/*
 * Revision 1.5  1997/08/04 22:16:44  arda
 * Fix mudlle so that it compiles with g++
 *
 * Revision 1.4  1996/02/09 14:58:10  arda
 * Security holes
 *
 * Revision 1.3  1993/05/02  07:37:37  un_mec
 * Owl: New output (mudlle ports).
 *
 * Revision 1.2  1993/03/29  09:23:37  un_mec
 * Owl: Changed descriptor I/O
 *      New interpreter / compiler structure.
 *
 * Revision 1.3  1993/03/14  16:13:53  dgay
 * Optimised stack & gc ops.
 *
 * Revision 1.1  1992/12/27  21:40:55  un_mec
 * Mudlle source, without any Mume extensions.
 *
 */

static char rcsid[] = "$Id: calloc.c,v 1.1 2003/10/15 15:58:50 emery Exp $";

#include <stdlib.h>
#include <stdio.h>
#ifdef MUME
#include <malloc.h>
#endif
#include "mudlle.h"
#include "calloc.h"
#include "utils.h"

#ifdef BWGC
block_t new_block(void)
/* Return: A new block from which to allocate some memory.
*/
{
  return NULL;
}

void free_block(block_t b)
/* Effect: Free all memory allocated in block b.
*/
{
}

void *allocate(block_t b, unsigned long size)
/* Effects: Allocates size bytes from block b. The result is aligned
     correctly for all types.
   Returns: A pointer to the start of the block.
   Note: In this implementation, 12 + average(size)/2 bytes will be wasted
     for every BLOCK_SIZE bytes allocated.
*/
{
  return (void *)GC_malloc(size);
}
#else

struct memblock
{
  struct memblock *next;
  char data[1];
};

block_t new_block(void)
/* Return: A new block from which to allocate some memory.
*/
{
  block_t newp = xmalloc(sizeof *newp);

  *newp = NULL;
  return newp;
}

void free_block(block_t b)
/* Effect: Free all memory allocated in block b.
*/
{
  struct memblock *blk = *b;

  while (blk)
    {
      struct memblock *prev = blk->next;

      free(blk);
      blk = prev;
    }
}

void *allocate(block_t b, unsigned long size)
/* Effects: Allocates size bytes from block b. The result is aligned
     correctly for all types.
   Returns: A pointer to the start of the block.
   Note: In this implementation, 12 + average(size)/2 bytes will be wasted
     for every BLOCK_SIZE bytes allocated.
*/
{
  struct memblock *x = xmalloc(size + sizeof(struct mem *));

  x->next = *b;
  *b = x;

  return x->data;
}
#endif
