/* $Log: mparser.h,v $
/* Revision 1.1  2003/10/15 15:58:57  emery
/* Initial check-in.
/*
/* Revision 1.1  2001/08/23 17:20:02  emery
/* The big fig newton.
/*
/* Revision 1.1.1.1  2001/06/28 19:48:18  dgay
/* Initial import of RC tests
/*
 * Revision 1.3  1997/08/04 22:17:04  arda
 * Fix mudlle so that it compiles with g++
 *
 * Revision 1.2  1996/02/09 14:58:38  arda
 * Security holes
 *
 * Revision 1.1  1995/06/04  14:24:30  arda
 * Rename/move some files, misc. junk
 *
 * Revision 1.7  1994/10/09  06:42:45  arda
 * Libraries
 * Type inference
 * Many minor improvements
 *
 * Revision 1.6  1994/08/16  19:16:10  arda
 * Mudlle compiler for sparc now fully functional (68k compiler now needs
 * updating for primitives).
 * Changes to allow Sparc trap's for runtime errors.
 * Also added flags to primitives for better calling sequences.
 *
 * Revision 1.3  1993/03/29  09:24:18  un_mec
 * Owl: Changed descriptor I/O
 *      New interpreter / compiler structure.
 *
 * Revision 1.3  1993/03/14  16:14:42  dgay
 * Optimised stack & gc ops.
 *
 * Revision 1.1  1992/12/27  21:41:27  un_mec
 * Mudlle source, without any Mume extensions.
 *
 */

#ifndef PARSER_H
#define PARSER_H

#include "tree.h"

struct yystype {
  char *string;
  char *symbol;
  int integer;
  constant tconstant;
  block tblock;
  function tfunction;
  clist tclist;
  vlist tvlist;
  cstlist tcstlist;
  component tcomponent;
  mtype tmtype;
  struct {
    int varargs;
    const char *var;
    vlist args;
  } tparameters;
  mfile tfile;
};

#define YYSTYPE struct yystype

#include "tokens.h"

mfile parse(block_t heap);
void parser_init(void);

#endif
