#include <string>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <time.h>

using namespace std;

int main (int argc, char * argv[])
{

  int maxVmDataSize = 0;

  char ** newArgv = new char * [argc];

  int i;
  for (i = 1; i < argc; i++) {
    newArgv[i-1] = argv[i];
  }
  newArgv[argc-1] = NULL;
  
  pid_t childPID = 1;

  if (!(childPID = fork())) {

    // Child process.

    usleep (100);
    execvp (newArgv[0], newArgv);
    exit (0);
  } else {
    int status;
    char fname[255];
    sprintf (fname, "/proc/%d/status", childPID);

    while (true) {
      struct timespec req;
      struct timespec rem;
      req.tv_sec = 0;
      req.tv_nsec = 100;
      nanosleep (&req, &rem);

      FILE * f = fopen (fname, "r");
      if (!f) {
	goto DONE;
      }
      while (!feof(f)) {
	char buf[255];
	if (!fgets (buf, 255, f)) {
	  goto DONE;
	}
	char * p;
	if ((p = strstr (buf, "VmData:"))) {
	  // Skip past the keyword.
	  p = strchr (p, ' ');
	  while (*p == ' ')
	    p++;
	  int v = atoi (p);
	  if (v > maxVmDataSize) {
	    maxVmDataSize = v;
	  }
	  break;
	}
      }
      if (f) {
	fclose (f);
      }
    }
  DONE:
    fprintf (stderr, "max VmData size = %d Kb\n", maxVmDataSize);
  }
  return 0;
}
